<?php

namespace Modules\User\Requests\Web;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\User\Enums\UserRoleEnum;
use Modules\User\Services\AccountService;
use Modules\User\Services\AddressService;

class DeleteAddressRequest extends FormRequest
{
    public function __construct(
        private AddressService $addressService,
        private AccountService $accountService,
    ){}

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $account = $this->accountService->getAccount();
        $rules = [];
        $address = $this->addressService->getItem($this->address);
        if ($address)
        {
            if ($address->user_id != $account['user']->id || $address->user_status != $account['status'])
            {
                $rules['not_exist'] = 'required';
            }
            if ($address->id == $account['user']->address_id)
            {
                $rules['default_address'] = 'required';
            }
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function messages()
    {
        $attributes= [
            'not_exist.required'=>__('web.not_exist'),
            'default_address.required'=>__('web.delete_default_address'),
        ];

        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            parent::failedValidation($validator);
        }
    }
}
